#!/usr/bin/perl
##########################
# MustLive/BPG MySQL Perl/CGI Client
# Copyright (C) 2002-2010 MustLive/BPG. Open Source Software, GPL
# MySQL Perl/CGI Client v1.08
# Last updated: 08.02.2010
# mustlive@mlfun.org.ua
##########################
# 볺     Mysql     
#  DBD::mysql - Mysql drivers for the Perl5 Database Interface (DBI)
$version = "1.08";
##########################

use CGI::Carp qw(fatalsToBrowser); #    
require "mysql_config.pl"; #  

#  Get
$temp = $ENV{'QUERY_STRING'};
@pairs = split(/&/,$temp);
foreach $item (@pairs) {
	my ($key,$value) = split(/=/,$item,2);
	$value =~ tr/+/ /;
	$value =~ s/%(..)/pack("c",hex($1))/ge;
	$value = AntiXSS($value); # Anti XSS
	$MANAGER{$key} = $value;
}

#  Post
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair(@pairs) {
	my ($name, $value) = split(/=/,$pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/ge;
	$value = AntiXSS($value); # Anti XSS
	$MANAGER{$name} = $value;
}

use DBI; #ϳ  DBD::mysql (DBI)
if ($dbname_default ne "") { #   Mysql  $dbname
	if ($dbname eq "") {
		$dbname=$dbname_default;
	}
	$dsn = "DBI:mysql:database=$dbname;host=$host;port=$port";
	if ($show_errors) {
		$dbh = DBI->connect($dsn, $user, $password, {'RaiseError' => 1});
	}
	else {
		$dbh = DBI->connect($dsn, $user, $password);
	}
}
else {
	print "Content-Type: text/html\n\n";
	&html_start;
	print qq~
<h3>    MySQL</h3>
<h4>   </h4>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
	&html_end;
	exit;
}
if ($tabname_default ne "") {
	if ($tabname eq "") {
		$tabname=$tabname_default;
	}
	$sth = $dbh->prepare("LISTFIELDS $tabname"); #   
	$sth->execute();
}
else {
	print "Content-Type: text/html\n\n";
	&html_start;
	print qq~
<h3>   </h3>
<h4>   </h4>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
	&html_end;
	exit;
}

$col_name = $sth->{'NAME'}; #   -   
$num_fields = $sth->{'NUM_OF_FIELDS'}; #  -
$col_prikey = $sth->{'mysql_is_pri_key'}; # -  " "
for (my $i=0;$i<=$num_fields-1;$i++) {
	if ($$col_prikey[$i] eq "1") {
		$colnum_prikey=$i;
	}
}
$col_nul = $sth->{'NULLABLE'}; #     
$col_num = $sth->{'mysql_is_num'}; #    (extra="auto_increment")
$col_types = $sth->{'TYPE'}; #  -

if ($MANAGER{'sql'} eq 'savedb') {&SQL_savedb;}
if ($MANAGER{'sql'} eq 'add') {&SQL_add;}
if ($MANAGER{'sql'} eq 'del') {&SQL_del;}
if ($MANAGER{'sql'} eq 'update') {&SQL_update;}
if ($MANAGER{'sql'} eq 'createtab') {&SQL_createtab;}

print "Content-Type: text/html\n\n";
&html_start;

if ($MANAGER{'sql'} eq 'updateform') {&SQL_updateform;}
if ($MANAGER{'sql'} eq 'savedbform') {&SQL_savedbform;}
if ($MANAGER{'sql'} eq 'addform') {&SQL_addform;}
if ($MANAGER{'sql'} eq 'createtabform') {&SQL_createtabform;}
if ($MANAGER{'sql'} eq 'query') {&SQL_query;}
if ($MANAGER{'sql'} eq 'about') {&About_box;}
if ($MANAGER{'sql'} eq 'screenshot') {&screenshot;}

#       
if ($MANAGER{'sort'}) {
	$sth = $dbh->prepare("select * from $tabname order by $MANAGER{'sort'}");
}
else {
	$sth = $dbh->prepare("select * from $tabname");
}
$sth->execute();
&SQL_showtable;

sub SQL_savedbform { #     MySQL    CSV 

print qq~
<form action="mysql.pl?sql=savedb" method="post">
<table width="700" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
	<tr>
		<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
			<tr align=center class=maincol>
				<td> &#146;     MySQL    CSV <br><br>
				<input type="text" name="file_db_save" size=30>&nbsp;&nbsp;<input type="submit" value=""><br><br>
~;
print "				     CSV : <input type=\"text\" name=\"csv_sym\" size=1 maxlength=5 value=\"$csv_symbol\"><br><br></td>";
print qq~
			</tr>
			<tr align=center class=maincol>
				<td>      ,     &quot;.csv&quot;,    .</td>
			</tr>
		</table></td>
	</tr>
</table>
</form>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
&html_end;
exit;

}

sub SQL_savedb { #   MySQL    CSV 

if ($MANAGER{file_db_save} eq "") {
	print "Content-Type: text/html\n\n";
	&html_start;
	print qq~
<h3 align=center>  &#146;     MySQL    CSV </h3>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
	&html_end;
	exit;
}
else {
	$filename=$MANAGER{file_db_save};
	$csv_sym=$MANAGER{csv_sym};
	if ($filename=~/\.csv$/ ne "1"){
		$filename.=".csv";
	}
	open (SAVEDB, ">$filename");
	$sth = $dbh->prepare("select * from $tabname");
	$sth->execute();
	while(my $a = $sth->fetchrow_arrayref){
		for (my $j=0;$j<$num_fields-1;$j++) {
			print SAVEDB "$$a[$j]$csv_sym";
		}
		print SAVEDB "$$a[$num_fields-1]\n";
	}
	close SAVEDB;
	&goto;
}

}

sub SQL_addform { #       Mysql

print qq~
<form action="mysql.pl?sql=add" method="post">
<table width="700" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
	<tr>
		<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
			<tr align=center class=maincol>
				<td>      <br><br><textarea name="add_query" rows=15 cols=40>
~;
print "INSERT INTO $tabname
(
";
for (my $j=0;$j<$num_fields-1;$j++) {
	print "$$col_name[$j],\n";
}
print "$$col_name[$num_fields-1]
)
VALUES
(
";

for (my $j=0;$j<$num_fields;$j++) {
	#        MySQL
	if ($$col_types[$j] == 9) {
		print "\"$date\"";
	}
	# -  extra="auto_increment"      
	elsif ($$col_nul[$j] ne "1" && $$col_num[$j] ne "0") {
		print "NULL";
	}
	else {
		print "\"\"";
	}
	print ",\n" if ($j != $num_fields-1);
}
print qq~
)</textarea>
<br><br><input type="submit" value=""></td>
			</tr>
		</table></td>
	</tr>
</table>
</form>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;

&html_end;
exit;

}

sub SQL_add { #     Mysql

if ($MANAGER{add_query} eq "") {
	print "Content-Type: text/html\n\n";
	&html_start;
	print qq~
<h3 align=center>  SQL </h3>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
	&html_end;
	exit;
}
else {
	$sth = $dbh->do($MANAGER{add_query});
	&goto;
}

}

sub SQL_del { #     Mysql

if ($MANAGER{sql_update} ne "") {
	print "Location: mysql.pl?sql=updateform&edit=$MANAGER{edit}\n\n";
}

$deltrue="0"; #       ""
foreach $pair (@pairs) {
	my ($name, $value)=split(/=/, $pair);
	$value=~ tr/+/ /;
	$value=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	if ($name=~/delchk/ eq "1") {
		$sth = $dbh->do("delete from $tabname where $$col_name[$colnum_prikey]=\"$value\"");
		$deltrue="1";
	}	
}
if ($deltrue ne "1"){
	print "Content-Type: text/html\n\n";
	&html_start;
	print qq~
<h3 align=center>      checkbox</h3>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
	&html_end;
	exit;
}
&goto;

}

sub SQL_updateform { #       Mysql

$edittrue="0"; #       ""
$temp=$ENV{'QUERY_STRING'};
@pairs=split(/&/,$temp);
foreach $item(@pairs) {
	my ($key,$value)=split (/=/,$item,2);
	$value=~tr/+/ /;
	$value=~ s/%(..)/pack("c",hex($1))/ge;
	if ($key eq "edit" && $value ne "") {
		$edittrue="1";
	}
}
if ($edittrue ne "1"){
	print qq~
<h3 align=center>      radiobutton</h3>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
}
else {
	$sth = $dbh->prepare("select count(*) from $tabname where $$col_name[$colnum_prikey]=\"$MANAGER{edit}\"");
	$sth->execute();
	$a = $sth->fetchrow_arrayref;
	if ($$a[0] == "0"){
		print qq~
<h3 align=center>     .</h3>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
	}
	else {
		print qq~
<form action="mysql.pl?sql=update" method="post">
<table width="700" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
	<tr>
		<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
			<tr align=center class=maincol>
				<td>³      <br><br><textarea name="updatequery" rows=10 cols=40>
~;
		$sth = $dbh->prepare("select * from $tabname where $$col_name[$colnum_prikey]=\"$MANAGER{edit}\"");
		$sth->execute();
		$a = $sth->fetchrow_arrayref;
		print "update $tabname set\n";
		for (my $j=0;$j<$num_fields-1;$j++) {
			print "$$col_name[$j]=\"$$a[$j]\",\n";
		}
		print "$$col_name[$num_fields-1]=\"$$a[$num_fields-1]\"\n";
		print "where\n$$col_name[$colnum_prikey]=$MANAGER{edit}";	
		print qq~
</textarea><br><br><input type="submit" value=""></td>
			</tr>
		</table></td>
	</tr>
</table>
</form>
<br>
<p align=center><a href="mysql.pl">  </a></p>~;
	}
}
&html_end;
exit;

}

sub SQL_update { #     Mysql

if ($MANAGER{updatequery} eq ""){
	print "Content-Type: text/html\n\n";
	&html_start;
	print qq~
<h3 align=center>      radiobutton</h3>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
	&html_end;
	exit;
}
else {
	$sth = $dbh->do($MANAGER{updatequery});	
}
&goto;

}

sub SQL_createtabform { #        

print qq~
<form action="mysql.pl?sql=createtab" method="post">
<table width="700" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
	<tr>
		<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
			<tr align=center class=maincol>
				<td>        <br><br><textarea name="createtab_query" rows=7 cols=40>create table _ (
_  primary key,
_ ( )
)</textarea><br><br></td>
			</tr>
			<tr align=center class=maincol>
				<td><br>       - &quot;primary key&quot;.<br>  : <i>tinyint, smallint, mediumint, int, bigint, float, double, decimal, date, datetime, timestamp, time, year, char, varchar, tinyblob, tinytext, text, blob, mediumblob, mediumtext, longblob, longtext, enum</i>  <i>set</i>.     auto_increment.<br><br>
				: <code>create table cds (id int auto_increment primary key, name text, cd text)</code>
				<br><br><input type="submit" value=""></td>
			</tr>
		</table></td>
	</tr>
</table>
</form>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;

&html_end;
exit;

}

sub SQL_createtab { #      

if ($MANAGER{createtab_query} eq "") {
	print "Content-Type: text/html\n\n";
	&html_start;
	print qq~
<h3 align=center>  SQL </h3>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
	&html_end;
	exit;
}
else {
	$sth = $dbh->do($MANAGER{createtab_query});
	&goto;
}

}

sub SQL_query { #   QUERY  Mysql

if ($MANAGER{sql_query} eq "") {
	print qq~
<h3 align=center>  SQL </h3>
<br>
<p align=center><a href="mysql.pl">  </a></p>
~;
	&html_end;	
}
else {
	if ($show_sqlform) {
		if ($log) {
			open (LOG, ">>$logname");
			print LOG "$MANAGER{sql_query}\n";
			close LOG;
		}
		if ($MANAGER{sql_query}=~/select/ eq "1") {
			$sth = $dbh->prepare($MANAGER{sql_query});
		}
		else {
			$sth = $dbh->do($MANAGER{sql_query});
			$sth = $dbh->prepare("select * from $tabname");
		}
	}
	else {
		$sth = $dbh->prepare("select * from $tabname");
	}
	$sth->execute();
	&SQL_showtable;
}
exit;

}

sub SQL_showtable { #     Mysql

print qq~<form action="mysql.pl?sql=del" method="post">
<table width="90%" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
	<tr>
		<td><table width="100%" border=0 cellspacing=1 cellpadding=2>
			<tr align=center>
				<th width="5%"><a href="mysql.pl"> N </a></th>				
~;
print "				<th width=\"1%\"><img src=\"$imgdel\"></th>\n";
print "				<th width=\"1%\"><img src=\"$imgedit\"></th>\n";
print "				<th width=\"10%\" class=upcase><a href=\"mysql.pl?sort=$$col_name[0]\"> $$col_name[0] </a></th>\n";
if ($num_fields>1) {
	for (my $j=1;$j<$num_fields-1;$j++) {
		print "				<th class=upcase><a href=\"mysql.pl?sort=$$col_name[$j]\"> $$col_name[$j] </a></th>\n";
	}
}
print "				<th width=\"10%\" class=upcase><a href=\"mysql.pl?sort=$$col_name[$num_fields-1]\"> $$col_name[$num_fields-1] </a></th>\n";
print "			</tr>\n";

#     Mysql
$i=1; #  
while(my $a = $sth->fetchrow_arrayref){
	print "			<tr align=center class=maincol>\n";
	print "				<td>$i</td>\n";
	print "				<td><input type=checkbox name=delchk$i value=\"$$a[$colnum_prikey]\"></td>\n";
	print "				<td><input type=radio name=edit value=\"$$a[$colnum_prikey]\"></td>\n";
	for (my $j=0;$j<=$num_fields-1;$j++) {
		if ($$col_types[$j] == 9) { #       MySQL
			$$a[$j] =~ s/(\d\d\d\d)-(\d\d)-(\d\d)/$3.$2.$1/;
		}
		print "				<td>$$a[$j]</td>\n";
	}
	print "			</tr>\n";
	$i++;
}

print qq~		</table></td>
	</tr>
</table>
<br>
<table width="90%" border="0" cellpadding="0" cellspacing="0" align=center>
<tr valign=top>
	<td width="47%"><table width="100%" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
	<tr>
		<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
		<tr align=center>
			<th class="header2"><img src="images/mysqlicon.gif" width=32 height=24>&nbsp; &nbsp;<img src="images/mysqlicon.gif" width=32 height=24></th>
		</tr>
		<tr align=center class=maincol>
			<td class=tabhead><a href="mysql.pl">  </a><br><br>
			<a href="mysql.pl?sql=addform"> </a><br><br>
			<input type="submit" value="  "><br><br>
			<input type="submit" name="sql_update" value="  "></td>
		</tr>
		</table></td>
	</tr>
	</table></td>
	<td width="6%"></td>
	<td width="47%"><table width="100%" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
	<tr>
		<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
		<tr align=center>
			<th class="header2"><img src="images/mysqlicon.gif" width=32 height=24>&nbsp; &nbsp;<img src="images/mysqlicon.gif" width=32 hegiht=24></th>
		</tr>
		<tr align=center class=maincol>
			<td class=tabhead><a href="mysql.pl?sql=about"> </a><br><br>
			<a href="mysql.pl?sql=savedbform">     CSV </a><br><br>
			<a href="mysql.pl?sql=createtabform">     </a></td>
		</tr>
		</table></td>
	</tr>
	</table></td>
</tr>
</table>
</form>
~;
if ($show_sqlform) {
	print qq~<br>
<table width="650" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
<form action="mysql.pl?sql=query" method="post">
<tr>
	<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
		<tr align=center>
			<th class="header2"><img src="images/mysqlicon.gif" width=32 heght=24>&nbsp;SQL    &nbsp;<img src="images/mysqlicon.gif" width=32 heght=24></th>
		</tr>
		<tr align=center class=maincol>
			<td>  SQL :&nbsp;&nbsp;<input type="text" name="sql_query" size="45">&nbsp;&nbsp;<input type="submit" value=" "></td>
		</tr>
~;
	if ($log) { #      SQL 
		open (LOG, "$logname");
		@log=<LOG>;
		$log=@log;
		$lastquery=$log[$log-1];
		close LOG;
		if ($lastquery ne "") {
			chomp $lastquery;
			print "			<tr align=center class=maincol>\n";
			print "				<td> SQL : <b>$lastquery</b></td>\n";
			print "			</tr>\n";
		}
	}
	print qq~	</table></td>
	</tr>
</form>
</table>~;
}
&html_end;

}

sub goto { #    
	print "Location: mysql.pl\n\n";
}

sub AntiXSS { # XSS 
	my $value = $_[0];

	$value =~ s/<([^>]|\n)+>//g;
	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;
	return $value;
}

sub About_box {

print qq~<table width="90%" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
<tr>
	<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
		<tr class=maincol>
		<td><h3> </h3>
			<p>볺     MySQL     .   -  MySQL database GUI client program ( MySQL Navigator     ). The purpose of MySQL Perl/CGI Client is to provide a useful and flexible client interface for MySQL database servers, and it can support multiple operating systems and languages.  DBD::mysql - Mysql drivers for the Perl5 Database Interface (DBI).</p>
			<p>   MySQL Perl/CGI Client       ,     .</p>
			<p>     볺:  ,       ( ,     &#146;),     ( , ,   ),      (  ,  ),     ,      MySQL ( ,     &#146;),    open source .    ,  񳺿         ()   open source  ( GPL).<br><br></p>
			<p><b>    :</b></p>
			<ul>
				<li> </li>
				<li>  </li>
				<li>  </li>
			</ul>
			<p><b>    :</b></p>
			<ul>
				<li>     CSV  (   )</li>
				<li>     </li>
				<li> SQL    </li>
			</ul>
			<p><b> :</b></p>
			<ul>
				<li> Cascading Style Sheet (<b>mysql.css</b>)    </li>
				<li>   ,  (header)  ʳ (footer)  html-     - &quot;html_start&quot;  &quot;html_end&quot;.</li>
				<li>   (<b>mysql_config.pl</b>),     :<br>
				<ul>
				<li><b>\$host</b> &#150;  MySQL  (localhost  )</li>
				<li><b>\$port</b> &#150;  MySQL  (3306  )</li>
				<li><b>\$user</b> &#150;  </li>
				<li><b>\$password</b> &#150;  </li>
				<li><b>\$dbname_default</b> &#150; &#146;    MySQL  </li>
				<li><b>\$tabname_default</b> &#150; &#146;    </li>
				<li><b>\$imgdel</b> &#150; &#146;     </li>
				<li><b>\$imgedit</b> &#150; &#146;     </li>
				<li><b>\$log</b> &#150;   SQL 
				<li><b>\$logname</b> &#150; -   SQL </li>
				<li><b>\$show_sqlform</b> &#150;   &quot;SQL    &quot;</li>			
				<li><b>\$csv_symbol</b> &#150;      CSV   </li>
				<li><b>\$show_errors</b> &#150;       MySQL</li>
				</ul>
				</li>
			</ul>
		</td>
		</tr>
	</table></td>
</tr>
</table>
<br>
<table width="90%" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
<tr>
	<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
		<tr class=maincol>
		<td><h3> </h3>
		<p align=center><a href="mysql.pl?sql=screenshot"><img src="images/tn_screenshot.jpg" weight="128" height="96" alt="screenshot" border="0"></a>
		<br>C  볺    Mozilla (   &quot;gb&quot;  &quot;mysql&quot;).</p>
		</td>
		</tr>
	</table></td>
</tr>
</table>
<br>
<table width="90%" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
<tr>
	<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
		<tr class=maincol>
		<td><h3> Open Source Software</h3>
		<p>Open Source means that it is possible for anyone to use and modify. Anybody can download MySQL Perl/CGI Client from the Internet and use it without paying anything. Anybody so inclined can study the source code and change it to fit their needs. MySQL Perl/CGI Client uses the GPL (<a href="http://www.gnu.org" target=_blank>GNU General Public License</a>), to define what you may and may not do with the software in different situations.  If you feel uncomfortable with the GPL or need to embed MySQL Perl/CGI Client into a commercial application you can buy a commercially licensed version.</p>
		</td>
		</tr>
	</table></td>
</tr>
</table>
<br>
<table width="90%" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
<tr>
	<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
		<tr class=maincol>
		<td><h3>   </h3>
		<p>For any additional information or if you want to translate program's description to your language (and I'll make a link to your site or put your description at my site), please, <a href="mailto:mustlive\@mlfun.org.ua?subject=MustLive/BPG MySQL Perl/CGI Client">contact me</a>.</p>
		</td>
		</tr>
	</table></td>
</tr>
</table>
<br>
<table width="90%" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
<tr>
	<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
		<tr class=maincol>
		<td><h3>   </h3>
		<p><b> 1.08</b> (08.02.2010)</p>
		<ul>
			<li>  XSS.</li>
			<li>     \$show_sqlform     &quot;SQL    &quot;,   䳿  SQL Injection  (  CSRF).</li>
			<li>      (  )   .</li>
		</ul>
		<p><b> 1.07</b> (26.12.2008)</p>
		<ul>
			<li> Full path disclosure .</li>
			<li>     \$show_errors         MySQL.</li>
			<li>  .</li>
		</ul>
		<p><b> 1.06</b> (29.12.2006)</p>
		<ul>
			<li>   -   \$sth-&gt;{'format_type_name'}  \$sth-&gt;{'TYPE'} (   DBI).</li>
			<li> XSS   "SQL    "   XSS         .</li>
			<li>   .</li>
		</ul>
		<p><b> 1.05</b> (28.07.2004)</p>
		<ul>
			<li>     DATE:
			<ul>
			<li>        ..   MySQL  YYYY-MM-DD;</li>
			<li>          DATE    .</li>
			</ul>
			</li>
			<li>     <b> </b> &#150; &quot; &quot;,    볺    Mozilla (   &quot;gb&quot;  &quot;mysql&quot;).</li>
			<li>     MySQL    .</li>
		</ul>
		<p><b> 1.04</b> (13.05.2003)</p>
		<ul>
			<li>   ,   .</li>
			<li>     <b> </b> &#150; &quot;   &quot;,         open source.</li>
		</ul>
		<p><b> 1.03</b> (22.04.2003)</p>
		<ul>
			<li>  <b>     CSV </b> &#150;      (   CSV )     ,        &quot;\$csv_symbol&quot; &#150;      CSV   ,         .</li>
		</ul>
		<p><b> 1.02</b> (15.03.2003)</p>
		<ul>
			<li> css-  html- &#150;      Mozilla (   1.3).</li>
		</ul>
		<p><b> 1.01</b> (1.12.2002)</p>
		<ul>
			<li>  ( css,      &#150;    ).</li>
			<li>     <b> </b> &#150; &quot;   &quot;,       .</li>
		</ul>
		<p><b> 1.0</b> (20.11.2002)</p>
		<ul>
			<li>  .   :  ,   ,   ,      CSV ,         SQL    .</li>
		</ul>
		</td>
		</tr>
	</table></td>
</tr>
</table>
<p align=center><a href="mysql.pl">  </a></p>
~;
&html_end;
exit;

}

sub screenshot { # 

print qq~<table width="90%" border="0" cellpadding="0" cellspacing="0" align=center class=maintabcol>
<tr>
	<td><table width="100%" border=0 cellspacing=1 cellpadding=5>
		<tr class=maincol>
		<td><h3>C  볺    Mozilla<br>
		(   &quot;gb&quot;  &quot;mysql&quot;)</h3>
		<p align=center><img src="images/screenshot.jpg" weight="800" height="600" alt="screenshot" border="0"></p>
		</td>
		</tr>
	</table></td>
</tr>
</table>
<p align=center><a href="mysql.pl">  </a></p>
~;
&html_end;
exit;

}

sub html_start { #   

print qq~<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>MustLive/BPG MySQL Perl/CGI Client</title>
<link rel="stylesheet" href="mysql.css" type="text/css">
</head>
<body leftmargin=10 topmargin=0 marginwidth=10 marginheight=0>
<br>
<table align="center" bgcolor="#000000" border="0" cellpadding="1" cellspacing="0" width="90%">
<tr>
	<td><table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td><div class=header>MustLive/BPG MySQL Perl/CGI Client v$version</div></td>
	</tr>
	</table></td>
</tr>
</table>
<br>~;

}

sub html_end { # ʳ  

print qq~<br>
<p class="copy"><b>Copyright &copy; <a href="mailto:mustlive\@mlfun.org.ua?subject=MustLive/BPG MySQL Perl/CGI Client">MustLive</a> / <a href="http://mlbpg.narod.ru" target="_blank">BPG</a> 2002-2010.</b><br><br>
<nobr>MustLive/BPG MySQL Perl/CGI Client</nobr> is Open Source Software. <nobr>MySQL Perl/CGI Client</nobr> uses the GPL (<a href="http://www.gnu.org" target="_blank">GNU General Public License</a>). You may use <nobr>MySQL Perl/CGI Client</nobr> for any purpose as long as you don't blame me for any damages incurred, and you may freely distribute it.</p>
</body>
</html>~;

}
